Subject: Re: bug#35639: 27.0.50; tramp fails to use ssh on LibreCMC (no base64 encoder available, and not mentioned in tramp manual)

From: Michael Albinus <[email-masked]>
Date: Thu, 09 May 2019 09:35:13 +0200

Jeronimo Pellegrini <[email-masked]> writes:

> Hi,

Hi Jeronimo,

> Before using tramp it has no content; after trying to connect,

Sure. Tramp is autoloaded, its symbols are available only after loading.

> Funny -- it lists awk as one method:
>
>  (b64 tramp-awk-encode tramp-awk-decode "test -c /dev/zero && od -v -t
> x1 -A n </dev/null && busybox awk '{}' </dev/null")
>
> But awk was not used, because 'od' is also not available.

I'm not a heavy awk user. The current awk based implementation has been
contributed by somebody else, IIRC. Do you know another way to use awk
for encoding/decoing base64, without "od"?

The current Tramp implementation is in the two variables
`tramp-awk-encode' and `tramp-awk-decode'. If we could find another
implementation, which runs also on your LibreCMC or OpenWRT machine, we
could add it to Tramp.

> 19:41:26.088945 tramp-sh-handle-file-local-copy (1) # File error:
> Wrong method specification for â€˜sshâ€™
>
> (this is the only occurrence of the string "error").
>
> As I had mentioned in the first message, this is because line 3174 of
> tramp.el was reached. It is the default case of a COND expression that
> has other two cases:
> - (or (tramp-local-host-p v)
>       (tramp-method-out-of-band-p v size))
> - (rem-enc ...)
>
> What happened is that (rem-enc ...) failed (because tramp could not use
> any encoding command), and fell through into the default action, which
> is this error.

Maybe we should enhance the error message.

>> Tramp shall describe in its manual, what does it need for
>> encoding/decoding. Agreed.
>
> Right...
> I will later in the week propose a patch to the manual, if that is OK.

Thanks.

> J.

Best regards, Michael.